//
// AG_AT.mq4               TD_DeMark_3_1_mod ( 11,9,10  16)
//    .
//         AutoGraf 4
//  , , sk@autograf.dp.ua, ICQ 64015987, http://autograf.dp.ua
//
//     .    .. 
// ..     .
// 0 
#property library   
 
#import "AG_Lib.ex4"
   int AG_Magic_Number();                          //  MN 
   int AG_Message(string& Message[], string _Text);//     Message[]
                          //    -    Manager[][]:
   int AG_Set_Instr(double& Manager[][], int ii, double v1, double v2, double v3,
                    double v4, double v5, double v6, int io , int ih); 
   int AG_Delete_Instr(double&Manager[][], int ii, int io,int ih);// 
#import "AG_Trade_Criterion_DeMark.ex4"
   int AG_Trade_Criterion_DeMark();                // - . .  3
#import
// 1 
int AG_AT(int Parol_AT, double Order[][], string Object[], double Instrument[][][][], 
          int Ddraw_Object[][], double& Tuning[], double& Manager[][], string& Message[])
   {    
//================================================================================== 2 ==
   static int Count = 0;                           //  
   int MN;                // MagicNumber    - AG_Magic_Number()
   int Ticket;                                     //  
   string Comm = "AG_AT";                          //  ( "AG_AT")
   double Price_Opn;                               //   
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   double Lot= NormalizeDouble(Tuning[1],2);       //  
   int Per   = NormalizeDouble(Tuning[2],0);       //  % ()
   int Slip  = NormalizeDouble(Tuning[3],0);       //  ()
   int SL    = NormalizeDouble(Tuning[4],0);       // StopLoss ()
   int TP    = NormalizeDouble(Tuning[5],0);       // TakeProfit ()
   int Ds    = NormalizeDouble(Tuning[6],0);       //  ()
   int St    = NormalizeDouble(Tuning[7],0);       //   ()
//---------------------------------------------------------------------------------- 3 --
   if (Count==0)              //        
      {                       //   ( 62 ):
      AG_Message(Message, "     . TD_DeMark_3_1_mod");//
      Count++;                //    
                        
      Lot   = 1.0;            // 1.0 ,     
      Per   = 0;              // 0 ,  %    . . 
      Slip  = 2;        
      SL    = 35;      
      TP    = 35;       
      Ds    = 20;       
      St    = 3;        
//---------------------------------------------------------------------------------- 4 --
      Tuning[1] = Lot;        //  
      Tuning[2] = Per;        //  % ()
      Tuning[3] = Slip;       //  ()
      Tuning[4] = SL;         // StopLoss ()
      Tuning[5] = TP;         // TakeProfit ()
      Tuning[6] = Ds;         //  ()
      Tuning[7] = St;         //   ()
      AG_Message(Message,"   .");//   (.62 .)
      return(1);              //    
      }
                              //  ,    AG_AT  ..
                              // ..   AutoGraf,    AG_ind..
                              // ..     .
//================================================================================== 5 ==
   bool Set_Orders = true;    //  ,    
   bool BS = true;            //  ,  BuyStop  
   bool SS = true;            //  ,  SellStop 
                              //        
   int Total_Ord = NormalizeDouble(Order[0][0],0);    //      
   for (int i=1; i<=Total_Ord; i++)                   //    
      {
      int Tip_Ord = NormalizeDouble(Order[i][6],0);   //   
      
      if (Tip_Ord==0 || Tip_Ord==1)                   //     ..
         {
         Set_Orders = false;                          // ..   
         break;                                       // ..  
         }
      if (Tip_Ord==4)                                 //   BuyStop..
         BS = false;                                  // ..     
      if (Tip_Ord==5)                                 //   SellStop..
         SS = false;                                  // ..     
      }
//================================================================================== 6 ==
   int Crit = AG_Trade_Criterion_DeMark();            //   
   if (Crit == -1)
      return(0);

   string SYMB = Symbol();                            //   
   double StopLevel = MarketInfo(SYMB, MODE_STOPLEVEL)*Point;//  
   if (Set_Orders == true)       //   .   ( )
      {
      if ( Crit > 0 )            //      .  
         {
         if (BS == true)         //    BuyStop
            {
            double Price = NormalizeDouble(ObjectGet("Opn_B", OBJPROP_PRICE1),Digits);
            if (NormalizeDouble(Price-Ask,Digits)< StopLevel)
               Price = NormalizeDouble(Ask + StopLevel, Digits);
            MN=AG_Magic_Number();//  MagicNumber ()                              
            OrderSend(SYMB,OP_BUYSTOP,Lot,Price,2,0,0,Comm,MN);//  BuyStop 
            return(1);           //  -   AG   .
            }
         if (SS == true)         //    SellStop
            {
            Price = NormalizeDouble(ObjectGet("Opn_S", OBJPROP_PRICE1),Digits);
            if (NormalizeDouble(Bid - Price,Digits)< StopLevel)
               Price = NormalizeDouble(Bid - StopLevel, Digits);
            MN=AG_Magic_Number();//  MagicNumber ()
            OrderSend(SYMB,OP_SELLSTOP,Lot,Price,2,0,0,Comm,MN);//  SellStop
            return(1);           //  -   AG   .
            }
         }
      }   
//---------------------------------------------------------------------------------- 7 --
   else                          //   ,   ..
      {                          // ..    
      for (i=1; i<=Total_Ord; i++)                       //    
         {
         Price_Opn = NormalizeDouble(Order[i][1],Digits);//    
         Ticket    = NormalizeDouble(Order[i][4],0);     //   
         Tip_Ord   = NormalizeDouble(Order[i][6],0);     //   
         if (Tip_Ord==4 || Tip_Ord==5)                   //   BuyStop  SellStop
            {
            AG_Message(Message, "    .");//( 62)
            AG_Message(Message, "   " + Ticket+ ".");//
            OrderDelete(Ticket);
            return(1);           //   -   AG   
            }
         if (Tip_Ord==0)                                 //   Buy
            {
            double StopLoss   = NormalizeDouble(Order[i][2],Digits);// StopLoss 
            double TakeProfit = NormalizeDouble(Order[i][3],Digits);// TakeProfit 
            if (NormalizeDouble(StopLoss,  Digits)== 0.0 ||  
                NormalizeDouble(TakeProfit,Digits)== 0.0   )
               {
               StopLoss   = NormalizeDouble(ObjectGet("Opn_S",  OBJPROP_PRICE1),Digits);
               TakeProfit = NormalizeDouble(ObjectGet("Cls_B1", OBJPROP_PRICE1),Digits);
               OrderModify(Ticket,Price_Opn,StopLoss,TakeProfit,0);//C StopLoss  TakeProfit
               return(1);        //  .    AG   
               }
            }   
         if (Tip_Ord==1)                                 //   Sell
            {
            StopLoss   = NormalizeDouble(Order[i][2],Digits);// StopLoss 
            TakeProfit = NormalizeDouble(Order[i][3],Digits);// TakeProfit 
            if (NormalizeDouble(StopLoss,  Digits)== 0.0 ||  
                NormalizeDouble(TakeProfit,Digits)== 0.0   )
               {
               StopLoss   = NormalizeDouble(ObjectGet("Opn_B", OBJPROP_PRICE1),Digits);
               TakeProfit = NormalizeDouble(ObjectGet("Cls_S1", OBJPROP_PRICE1),Digits);
               OrderModify(Ticket,Price_Opn,StopLoss,TakeProfit,0);//C StopLoss  TakeProfit
               return(1);        //  .    AG   
               }
            }
         }
              
      }
//================================================================================== 8 ==
   // ,      (   )
   int Obj_Total_AG = StrToInteger(Object[0]);// . ,  AG 4
   for(int k=0; k<=Obj_Total_AG; k++)        //    
      {
      string Obj_Name = Object[k];           //   
      if (Obj_Name == "Opn_B")               //      Buy
         int Index_0 = k; 
      if (Obj_Name == "Cls_B1")              //     1 . Buy
         int Index_1 = k;
      if (Obj_Name == "Cls_B2")              //     2 . Buy
         int Index_2 = k;
      if (Obj_Name == "Cls_B3")              //     3 . Buy
         int Index_3 = k;
         
      if (Obj_Name == "Opn_S")               //      Sell
         int Index_4 = k;
      if (Obj_Name == "Cls_S1")              //     1 . Sell
         int Index_5 = k;
      if (Obj_Name == "Cls_S2")              //     2 . Sell
         int Index_6 = k;
      if (Obj_Name == "Cls_S3")              //     3 . Sell
         int Index_7 = k;
      }
//================================================================================== 9 ==
   for (i=1; i<=Total_Ord; i++)               //    
      {
      Tip_Ord= NormalizeDouble(Order[i][6],0);//   
      Ticket = NormalizeDouble(Order[i][4],0);//  
      
      if (Tip_Ord == 4) //    BuyStop
         {              //  . __  BuyStop  :
         if( NormalizeDouble(Instrument[i][1][11][0],1)< 1.0 )
            // i  =  
            // 1  =    (OR)
            // 11 =   __
            // 0  =   
            // 1.0=   (0.5=    , 
            //                             0.0 =  )(  1 )
            {
            int Tm = 25*Period()*60;          //   ,  - 25 
                        //   11, __
            AG_Set_Instr(Manager, 11, Tm, 0, 0, 4, Index_0, 32, Ticket, 1);
            // 11 =  
            // Tm =     , 
            // 0  =  
            // 0  =   
            // 4  =  
            // Index_0  =     Object[0] 
            // 32 =    (RegLine = 32, UpLine=0, DnLine=1)
            // Ticket  =  
            // 1  =    (OR=1)
            AG_Message(Message, " BuyStop " + Ticket+ " ");//( 62)
            AG_Message(Message, "  __.");
            }
         }
//--------------------------------------------------------------------------------- 10 --
      if (Tip_Ord == 5) //    SellStop
         {              //  . __  SellStop  :
         if( NormalizeDouble(Instrument[i][1][11][0],1)< 1.0 )
            {
            Tm = 25*Period()*60;           //   ,  - 25 
                        //   11, __
            AG_Set_Instr(Manager, 11, Tm, 0, 0, 4, Index_4, 32,  Ticket, 1);    
            AG_Message(Message, " SellStop " + Ticket+ " ");//( 62)
            AG_Message(Message, "  __.");
            }
         }      
//================================================================================= 11 ==
      if (Tip_Ord == 0) //    Buy
         {              //  . __  SellStop  :
         if( NormalizeDouble(Instrument[i][2][9][0],1)< 1.0 )
            {
            // 2 =    (StopLoss)
            Tm = -5*Period()*60; //   ,  - -5 
            //   11, __  TakeProfit:
            AG_Set_Instr(Manager, 9, Tm, 0, 0, 4, Index_4, 32, Ticket, 2);    
            // 9  =  
            // Tm =     , 
            // 0  =  
            // 0  =  
            // 4  =  
            // Index_4  =     Object[0]
            // 32  =    (http://autograf.dp.ua/Pages/2/26/268.htm)
            // Ticket =  
            // 2 =    (StopLoss)
            AG_Message(Message, " StopLoss Buy " + Ticket+ "  ");
            AG_Message(Message, "  ___.");
//--------------------------------------------------------------------------------- 12 --
            if( NormalizeDouble(Instrument[1][1][16][0],0)==0.0 )
               {                          //   .16:
               double Pr_16 = NormalizeDouble(Order[1][1]+(Order[1][3]-Order[1][1])/2,Digits);
               double Lot_16 = 0.4;       //    
                                          //   16 __
               AG_Set_Instr(Manager, 16, 25, Pr_16, 0, 0, 0, Lot_16, Ticket, 1);
               // 16 =  
               // 25 =  
               // Pr_16 =   
               // 0  =   (  ,   AutoGraf) 
               // 0  =  
               // 0  =  
               // Lot_16 =  ,  
               // Ticket  =  
               // 1  =    (OR=1)
               AG_Message(Message, "  Sell " + Ticket+ " ");//( 62)
               AG_Message(Message, "  __.");
               }
            }
         }      
//================================================================================= 13 ==
      if (Tip_Ord == 1) //    Sell
         {              //  . __  SellStop  :
         if( NormalizeDouble(Instrument[i][2][10][0],1)< 1.0 )
            {
            // 2 =    (StopLoss)
            Tm = -5*Period()*60; //   ,  - -5 
            //   11, __  TakeProfit:
            AG_Message(Message, "Index_5 = " + Index_5+ ".");//( 62)
            AG_Set_Instr(Manager, 10, Tm, 0, 0, 4, Index_0, 32, Ticket, 2);    
            // 10 =  
            // Tm =     , 
            // 0  =  
            // 0  =  
            // 4  =  
            // Index_0  =     Object[0]
            // 32  =    (http://autograf.dp.ua/Pages/2/26/268.htm)
            // Ticket =  
            // 2 =    (StopLoss)
            AG_Message(Message, " StopLoss Sell " + Ticket+ "  ");
            AG_Message(Message, "  ___.");
//--------------------------------------------------------------------------------- 14 --
            if( NormalizeDouble(Instrument[1][1][16][0],0)==0.0 )
               {                          //   .16:
               Pr_16 = NormalizeDouble(Order[1][1]-(Order[1][1]-Order[1][3])/2,Digits);
               Lot_16 = 0.4;              //    
                                          //   16 __
               AG_Set_Instr(Manager, 16, 25, Pr_16, 0, 0, 0, Lot_16, Ticket, 1);
               AG_Message(Message, "  Sell " + Ticket+ " ");//( 62)
               AG_Message(Message, "  __.");
               }
            }
         }      
      }
//================================================================================= 15 ==
   return(1);           //  
   }
//    16 